"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/assets/images/pdf.png
var require_pdf = __commonJS({
  "src/assets/images/pdf.png"(exports2, module2) {
    module2.exports = "./pdf-DRLKBAV4.png";
  }
});

// src/assets/images/file.png
var require_file = __commonJS({
  "src/assets/images/file.png"(exports2, module2) {
    module2.exports = "./file-7YLA65K6.png";
  }
});

// src/assets/images/attachment.png
var require_attachment = __commonJS({
  "src/assets/images/attachment.png"(exports2, module2) {
    module2.exports = "./attachment-KGXTGNAI.png";
  }
});

// src/index.ts
var src_exports = {};
__export(src_exports, {
  InputFile: () => InputFile_default,
  MediaTypes: () => MediaTypes,
  formatImages: () => formatImages,
  formatPdf: () => formatPdf,
  get_url_extension: () => get_url_extension
});
module.exports = __toCommonJS(src_exports);

// src/components/InputFile.tsx
var import_react9 = __toESM(require("react"));
var import_react_native10 = require("react-native");

// src/components/PreviewFilesSelected.tsx
var import_react6 = __toESM(require("react"));
var import_react_native7 = require("react-native");

// src/components/CardAttachment.tsx
var import_react5 = __toESM(require("react"));
var import_react_native6 = require("react-native");

// src/components/ViewerFiles.tsx
var import_react3 = __toESM(require("react"));
var import_react_native4 = require("react-native");
var import_react_native_sheet = require("react-native-sheet");

// src/components/types.ts
var MediaTypes = {
  images: "image/*",
  pdf: "pdf/*",
  all: "*/*"
};
var formatImages = ["gif", "png", "bmp", "jpeg", "jpg"];
var formatPdf = ["pdf"];
var get_url_extension = (url) => {
  if (!url)
    return "";
  return url.split(/[#?]/)[0].split(".").pop()?.trim();
};

// src/components/ViewerImage.tsx
var import_react2 = __toESM(require("react"));
var import_react_native_image_viewing = __toESM(require("react-native-image-viewing"));
var import_react_native3 = require("react-native");

// src/components/Button.tsx
var import_react = __toESM(require("react"));
var import_react_native2 = require("react-native");

// src/components/styles.ts
var import_react_native = require("react-native");
var Styles = import_react_native.StyleSheet.create({
  button: {
    padding: 16,
    width: "100%",
    borderRadius: 10,
    marginVertical: 4,
    flexDirection: "row",
    alignItems: "center",
    justifyContent: "center"
  },
  labelButton: {
    fontSize: 16,
    textAlign: "center",
    marginHorizontal: 4
  },
  containerFileType: {
    borderRadius: 8,
    padding: 20,
    borderWidth: 1,
    borderColor: "#EBEBEB",
    justifyContent: "center",
    alignItems: "center"
  },
  labelContainer: {
    fontSize: 16,
    color: "black"
  }
});

// src/components/Button.tsx
var import_vector_icons = require("@expo/vector-icons");
var Button = ({ label, onPress, icon, labelStyle, colorLoading, iconColor = "black", iconSize = 20, isLoading, disabled, contentStyle }) => {
  return /* @__PURE__ */ import_react.default.createElement(import_react_native2.Pressable, { onPress, style: import_react_native2.StyleSheet.flatten([Styles.button, contentStyle, disabled && { backgroundColor: "#E9E7E7" }]) }, icon && /* @__PURE__ */ import_react.default.createElement(
    import_vector_icons.Ionicons,
    {
      name: icon,
      size: iconSize,
      color: iconColor
    }
  ), isLoading && /* @__PURE__ */ import_react.default.createElement(import_react_native2.ActivityIndicator, { size: "small", color: colorLoading ?? iconColor }), label && /* @__PURE__ */ import_react.default.createElement(import_react_native2.Text, { style: [Styles.labelButton, labelStyle, disabled && { color: "#ADADAD" }] }, label));
};
var Button_default = Button;

// src/components/ViewerImage.tsx
var ViewerImage = ({
  source,
  visible,
  onClose,
  onLongPress
}) => {
  return /* @__PURE__ */ import_react2.default.createElement(
    import_react_native_image_viewing.default,
    {
      images: [source],
      imageIndex: 0,
      visible,
      doubleTapToZoomEnabled: true,
      onRequestClose: () => onClose && onClose(),
      FooterComponent: () => /* @__PURE__ */ import_react2.default.createElement(import_react_native3.View, { style: { paddingVertical: 20 } }, /* @__PURE__ */ import_react2.default.createElement(
        Button_default,
        {
          onPress: () => onLongPress && onLongPress(),
          icon: "share-outline",
          iconColor: "white",
          iconSize: 35
        }
      ))
    }
  );
};
var ViewerImage_default = ViewerImage;

// src/components/ViewerFiles.tsx
var { height: heightScreen } = import_react_native4.Dimensions.get("screen");
var ViewerFiles = ({
  typeFile,
  url,
  visible,
  onClose
}) => {
  const isImage = formatImages.includes(typeFile);
  const bottomSheet = import_react3.default.useRef(null);
  import_react3.default.useEffect(() => {
    if (visible) {
      bottomSheet.current?.show();
    } else {
      bottomSheet.current?.hide();
    }
  }, [visible]);
  if (isImage) {
    return /* @__PURE__ */ import_react3.default.createElement(
      ViewerImage_default,
      {
        visible,
        source: { uri: url },
        onClose: () => onClose && onClose()
      }
    );
  }
  return /* @__PURE__ */ import_react3.default.createElement(
    import_react_native_sheet.BottomSheet,
    {
      height: heightScreen,
      ref: bottomSheet,
      draggable: false,
      sheetStyle: { backgroundColor: "white" }
    },
    /* @__PURE__ */ import_react3.default.createElement(import_react_native4.Text, { style: styles.textUnsupport }, "Sorry, unsupported media type")
  );
};
var styles = import_react_native4.StyleSheet.create({
  contentModal: {
    padding: 24,
    flexDirection: "column",
    alignItems: "center"
  },
  textUnsupport: {
    fontSize: 14
  },
  labelsButtonPdf: {
    fontSize: 14
  },
  buttonClose: {
    borderRadius: 8,
    margin: 12,
    width: 40,
    padding: 4,
    borderColor: "black",
    borderWidth: 1
  },
  buttonDownload: {
    flex: 1,
    borderRadius: 8,
    margin: 12,
    padding: 4,
    borderColor: "black",
    borderWidth: 1
  },
  contentClose: {
    marginTop: 12,
    flexDirection: "row",
    alignItems: "center",
    justifyContent: "flex-end",
    width: "100%"
  }
});
var ViewerFiles_default = ViewerFiles;

// src/components/CardAttachment.tsx
var import_vector_icons2 = require("@expo/vector-icons");

// src/components/GetIconType.tsx
var import_react4 = __toESM(require("react"));
var import_react_native5 = require("react-native");

// src/assets/images/index.ts
var images = {
  pdfIcon: require_pdf(),
  fileIcon: require_file(),
  attachmentIcon: require_attachment()
};

// src/components/GetIconType.tsx
var GetIconType = ({ type, imageUrl }) => {
  const isImage = type ? formatImages.includes(type) : false;
  const isPdf = type ? formatPdf.includes(type) : false;
  if (isImage && !!imageUrl) {
    return /* @__PURE__ */ import_react4.default.createElement(import_react_native5.Image, { source: { uri: imageUrl }, style: styles2.sizeIcons });
  }
  if (isPdf) {
    return /* @__PURE__ */ import_react4.default.createElement(import_react_native5.Image, { resizeMode: "contain", source: images.pdfIcon, style: styles2.sizeIcons });
  }
  return /* @__PURE__ */ import_react4.default.createElement(import_react_native5.Image, { resizeMode: "contain", source: images.fileIcon, style: styles2.sizeIcons });
};
var styles2 = import_react_native5.StyleSheet.create({
  sizeIcons: { width: 20, height: 20, marginRight: 10 }
});
var GetIconType_default = GetIconType;

// src/components/CardAttachment.tsx
var CardAttachment = ({
  name,
  type,
  linkAttachment,
  onRemove,
  horizontal = false,
  withIcon = false
}) => {
  const [visibleViewer, setVisibleViewer] = import_react5.default.useState(false);
  const handleShowImage = () => {
    setVisibleViewer(true);
  };
  return /* @__PURE__ */ import_react5.default.createElement(import_react5.default.Fragment, null, /* @__PURE__ */ import_react5.default.createElement(
    import_react_native6.TouchableOpacity,
    {
      activeOpacity: 1,
      onPress: handleShowImage,
      style: horizontal ? styles3.containerCardHorizontal : styles3.containerCard
    },
    /* @__PURE__ */ import_react5.default.createElement(import_react_native6.View, { style: horizontal ? styles3.contentHorizontal : styles3.content }, withIcon && /* @__PURE__ */ import_react5.default.createElement(GetIconType_default, null), /* @__PURE__ */ import_react5.default.createElement(import_react_native6.Text, { style: styles3.textName, numberOfLines: 2 }, name), onRemove && /* @__PURE__ */ import_react5.default.createElement(
      import_react_native6.TouchableOpacity,
      {
        style: { marginLeft: 2 },
        onPress: () => onRemove?.()
      },
      /* @__PURE__ */ import_react5.default.createElement(
        import_vector_icons2.Ionicons,
        {
          name: "close-circle-outline",
          size: 30,
          color: "#1F3552"
        }
      )
    ))
  ), /* @__PURE__ */ import_react5.default.createElement(
    ViewerFiles_default,
    {
      typeFile: type,
      url: linkAttachment,
      visible: visibleViewer,
      onClose: () => setVisibleViewer(false)
    }
  ));
};
var styles3 = import_react_native6.StyleSheet.create({
  containerCard: {
    width: "100%",
    backgroundColor: "white",
    marginVertical: 2,
    paddingHorizontal: 5,
    paddingVertical: 10,
    borderRadius: 5
  },
  containerCardHorizontal: {
    backgroundColor: "white",
    borderRadius: 5,
    width: 220
  },
  contentHorizontal: {
    flexDirection: "row",
    alignItems: "center",
    justifyContent: "flex-start"
  },
  content: {
    flexDirection: "row",
    alignItems: "center",
    justifyContent: "space-between"
  },
  textName: {
    fontSize: 16,
    color: "#5E9CEF",
    fontWeight: "500",
    width: "80%"
  }
});
var CardAttachment_default = CardAttachment;

// src/components/PreviewFilesSelected.tsx
var PreviewFilesSelected = ({
  files,
  onRemove,
  disabledChanges,
  statusUploadingFile
}) => {
  const renderFiles = ({ item, index }) => {
    const extensionAttachment = get_url_extension(item.uri.toLowerCase());
    if (!extensionAttachment)
      return null;
    return /* @__PURE__ */ import_react6.default.createElement(
      CardAttachment_default,
      {
        name: item.fileName,
        type: extensionAttachment,
        linkAttachment: item.uri,
        downloadFile: false,
        onRemove: () => !disabledChanges && onRemove(index),
        isLoading: statusUploadingFile === "uploading"
      }
    );
  };
  return /* @__PURE__ */ import_react6.default.createElement(import_react_native7.View, { style: { width: "100%", marginBottom: 10 } }, /* @__PURE__ */ import_react6.default.createElement(
    import_react_native7.FlatList,
    {
      data: files,
      keyExtractor: (_, index) => `file-preview-${index}`,
      renderItem: renderFiles,
      scrollEnabled: false,
      nestedScrollEnabled: true
    }
  ));
};
var PreviewFilesSelected_default = PreviewFilesSelected;

// src/components/ModalOptionsUploadFile.tsx
var import_react_native8 = require("react-native");
var import_react7 = __toESM(require("react"));
var ImagePicker = __toESM(require("expo-image-picker"));
var DocumentPicker = __toESM(require("expo-document-picker"));

// src/utils/index.ts
var getNameImagePicker = (uri) => {
  const str = uri.split("/");
  return str[str.length - 1] ?? `imagePicker${Math.random()}`;
};
var mapperDataFiles = (dataFile, dataImage) => {
  if (dataFile && dataFile.canceled === false) {
    return dataFile.assets.map((file) => ({
      mimeType: file.mimeType ?? "",
      uri: file.uri,
      fileSize: file.size ?? 30,
      fileName: file.name
    }));
  }
  if (!dataImage)
    return [];
  return dataImage.map((asset) => ({
    mimeType: asset.type ?? "Image",
    uri: asset.uri,
    fileSize: asset.fileSize ?? 20,
    fileName: getNameImagePicker(asset.uri)
  }));
};

// src/components/ModalOptionsUploadFile.tsx
var ModalOptionsUploadFile = ({
  files,
  setFiles,
  openModal,
  onOpenModal,
  multiple,
  typeFiles = "all",
  copyToCacheDirectory = false,
  noConcatenation = false
}) => {
  const [cameraPermissionStatus, setCameraPermissionStatus] = import_react7.default.useState("undetermined");
  const typeMedia = MediaTypes[typeFiles];
  import_react7.default.useEffect(() => {
    ImagePicker.getCameraPermissionsAsync().then(({ status }) => {
      if (status !== "granted") {
        requestCameraPermission().catch((err) => console.log("Camera permission error::", err));
      }
    });
  }, []);
  const requestCameraPermission = async () => {
    const { status } = await ImagePicker.requestCameraPermissionsAsync();
    setCameraPermissionStatus(status);
  };
  const handlePickerFiles = () => {
    DocumentPicker.getDocumentAsync({
      multiple,
      copyToCacheDirectory,
      type: typeMedia
    }).then((data) => {
      if (data.canceled)
        return;
      const dataMap = mapperDataFiles(data);
      if (!multiple || noConcatenation) {
        setFiles(dataMap);
        return;
      }
      setFiles([...files, ...dataMap]);
    });
  };
  const dontPermit = () => {
    requestCameraPermission().catch((err) => console.log("Camera permission error::", err));
  };
  const pickImage = (takePhoto = false) => {
    onOpenModal(false);
    const configPicker = {
      mediaTypes: ImagePicker.MediaTypeOptions.All,
      aspect: [4, 3],
      quality: 1,
      allowsMultipleSelection: multiple
    };
    if (takePhoto) {
      if (cameraPermissionStatus !== "granted") {
        return dontPermit();
      }
      ImagePicker.launchCameraAsync(configPicker).then((result) => {
        if (result.canceled)
          return;
        const dataMap = mapperDataFiles(void 0, result.assets);
        if (!multiple || noConcatenation) {
          setFiles(dataMap);
          return;
        }
        setFiles([...files, ...dataMap]);
      });
      return;
    }
    ImagePicker.launchImageLibraryAsync(configPicker).then((result) => {
      if (result.canceled)
        return;
      const dataMap = mapperDataFiles(void 0, result.assets);
      if (!multiple || noConcatenation) {
        setFiles(dataMap);
        return;
      }
      setFiles([...files, ...dataMap]);
    }).catch((error) => console.log("[launchImageLibraryAsync] error::", error));
  };
  if (!openModal)
    return null;
  return /* @__PURE__ */ import_react7.default.createElement(import_react_native8.View, { style: styles4.modalMenu }, typeFiles !== "pdf" && /* @__PURE__ */ import_react7.default.createElement(import_react7.default.Fragment, null, /* @__PURE__ */ import_react7.default.createElement(
    Button_default,
    {
      onPress: () => pickImage(),
      label: "Photo Library",
      labelStyle: { fontSize: 14, color: "#1F3552" },
      contentStyle: {
        paddingVertical: 5,
        alignItems: "center",
        justifyContent: "flex-start"
      }
    }
  ), /* @__PURE__ */ import_react7.default.createElement(
    Button_default,
    {
      onPress: () => pickImage(true),
      label: "Take Photo",
      labelStyle: { fontSize: 14, color: "#1F3552" },
      contentStyle: {
        paddingVertical: 5,
        alignItems: "center",
        justifyContent: "flex-start"
      }
    }
  )), /* @__PURE__ */ import_react7.default.createElement(
    Button_default,
    {
      onPress: () => {
        handlePickerFiles();
        onOpenModal(false);
      },
      label: "Choose Files",
      labelStyle: { fontSize: 14, color: "#1F3552" },
      contentStyle: {
        paddingVertical: 5,
        alignItems: "center",
        justifyContent: "flex-start"
      }
    }
  ));
};
var styles4 = import_react_native8.StyleSheet.create({
  modalMenu: {
    padding: 10,
    shadowOffset: {
      width: 0,
      height: 8
    },
    elevation: 16,
    shadowRadius: 16,
    shadowColor: "rgba(47, 51, 80, 0.12)",
    shadowOpacity: 1,
    borderTopLeftRadius: 12,
    borderTopRightRadius: 12,
    borderBottomRightRadius: 12,
    borderBottomLeftRadius: 12,
    bottom: 40,
    right: 10,
    backgroundColor: "white"
  }
});
var ModalOptionsUploadFile_default = ModalOptionsUploadFile;

// src/components/Container.tsx
var import_react8 = __toESM(require("react"));
var import_vector_icons3 = require("@expo/vector-icons");
var import_react_native9 = require("react-native");
var Container = ({ containerStyle, onPress, labelContainer, label, iconColor = "\xB71F3552", required = false }) => {
  return /* @__PURE__ */ import_react8.default.createElement(
    import_react_native9.TouchableOpacity,
    {
      style: import_react_native9.StyleSheet.flatten([Styles.containerFileType, containerStyle]),
      activeOpacity: 1,
      onPress
    },
    /* @__PURE__ */ import_react8.default.createElement(import_vector_icons3.Ionicons, { name: "md-cloud-upload-outline", size: 24, color: iconColor }),
    /* @__PURE__ */ import_react8.default.createElement(import_react_native9.Text, { style: import_react_native9.StyleSheet.flatten([Styles.labelContainer, labelContainer]) }, label ?? "Upload", required && /* @__PURE__ */ import_react8.default.createElement(import_react_native9.Text, { style: { color: "red" } }, "*"))
  );
};
var Container_default = Container;

// src/components/InputFile.tsx
var InputFile = ({
  label,
  multiple = true,
  previewFiles = false,
  typeFiles = "all",
  onChange,
  typeInputFile: type = "button",
  onRemoveFile,
  required,
  noConcatenation = false,
  ...rest
}) => {
  const [filesSelected, setFilesSelected] = import_react9.default.useState([]);
  const [showModalMenu, setShowModalMenu] = import_react9.default.useState(false);
  const setFilesAssets = (fileAssets) => {
    setShowModalMenu(false);
    setFilesSelected(fileAssets);
    onChange?.(fileAssets);
  };
  const handleRemoveFile = (indexFile) => {
    setFilesSelected((prev) => {
      return prev.filter((_, index) => index !== indexFile);
    });
    onRemoveFile?.(indexFile);
  };
  const renderPreviewFiles = import_react9.default.useMemo(() => {
    if (!previewFiles || !filesSelected.length)
      return null;
    return /* @__PURE__ */ import_react9.default.createElement(
      PreviewFilesSelected_default,
      {
        files: filesSelected.reverse(),
        onRemove: handleRemoveFile
      }
    );
  }, [filesSelected]);
  return /* @__PURE__ */ import_react9.default.createElement(import_react9.default.Fragment, null, type === "button" ? /* @__PURE__ */ import_react9.default.createElement(
    Button_default,
    {
      onPress: () => setShowModalMenu(!showModalMenu),
      label: label ?? "Upload",
      labelStyle: import_react_native10.StyleSheet.flatten([{ color: "#1F3552" }, rest.labelButtonStyle]),
      contentStyle: import_react_native10.StyleSheet.flatten([{
        padding: 0,
        marginBottom: 30,
        justifyContent: "flex-start"
      }, rest.buttonStyle]),
      ...rest
    }
  ) : /* @__PURE__ */ import_react9.default.createElement(
    Container_default,
    {
      iconColor: "#1F3552",
      onPress: () => setShowModalMenu(!showModalMenu),
      label: label ?? "Upload",
      required,
      ...rest
    }
  ), renderPreviewFiles, /* @__PURE__ */ import_react9.default.createElement(
    ModalOptionsUploadFile_default,
    {
      setFiles: setFilesAssets,
      files: filesSelected,
      openModal: showModalMenu,
      onOpenModal: setShowModalMenu,
      typeFiles,
      multiple,
      noConcatenation
    }
  ));
};
var InputFile_default = InputFile;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  InputFile,
  MediaTypes,
  formatImages,
  formatPdf,
  get_url_extension
});
//# sourceMappingURL=index.js.map